var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name2 in all)
    __defProp(target, name2, { get: all[name2], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/github/src/index.ts
var src_exports = {};
__export(src_exports, {
  install: () => install,
  name: () => name,
  using: () => using
});
module.exports = __toCommonJS(src_exports);
var import_zhin = require("zhin");
var import_plugin_database = require("@zhinjs/plugin-database");
var import_plugin_http = require("@zhinjs/plugin-http");

// packages/github/src/markdown.ts
var import_icqq_cq_enable = require("icqq-cq-enable");
var import_icqq = require("icqq");
var import_marked = require("marked");
function renderToken(token) {
  if (token.type === "code") {
    return token.text + "\n";
  } else if (token.type === "paragraph") {
    return render(token.tokens);
  } else if (token.type === "image") {
    return (0, import_icqq_cq_enable.toCqcode)({ message: [import_icqq.segment.image(token.href)] });
  } else if (token.type === "blockquote") {
    return token.text;
  }
  return token.raw;
}
__name(renderToken, "renderToken");
function render(tokens) {
  return tokens.map(renderToken).join("");
}
__name(render, "render");
function transform(source) {
  if (!source)
    return "";
  source = source.replace(/^<!--(.*)-->$/gm, "");
  return render(import_marked.marked.lexer(source)).trim().replace(/\n\s*\n/g, "\n");
}
__name(transform, "transform");

// packages/github/src/events.ts
var defaultEvents = {
  commitComment: {
    created: true
  },
  issueComment: {
    created: true
  },
  issues: {
    closed: true,
    opened: true
  },
  milestone: {
    created: true
  },
  pullRequest: {
    closed: true,
    opened: true,
    reopened: true,
    readyForReview: true,
    convertedToDraft: true,
    reviewRequested: true
  },
  pullRequestReview: {
    submitted: true
  },
  pullRequestReviewComment: {
    created: true
  },
  star: {
    created: true
  }
};
function addListeners(on) {
  const createFactory = /* @__PURE__ */ __name((callback) => (event, handler) => {
    on(event, (payload) => Reflect.apply(callback, null, [event, payload, handler]));
  }, "createFactory");
  const onComment = createFactory((event, payload, handler) => {
    const { user, body, html_url, url } = payload.comment;
    if (user.type === "Bot")
      return;
    const [target, replies] = handler(payload);
    if (payload.action === "deleted") {
      return [`${user.login} deleted a comment on ${target}`];
    }
    const { padding } = replies;
    delete replies.padding;
    const index = html_url.indexOf("#");
    const operation = payload.action === "created" ? "commented" : "edited a comment";
    return [`${user.login} ${operation} on ${target}
${transform(body)}`, {
      link: [html_url],
      react: [url + `/reactions`],
      shot: [
        html_url.slice(0, index),
        html_url.slice(index),
        padding
      ],
      ...replies
    }];
  });
  onComment("commit_comment", ({ repository, comment }) => {
    const { full_name } = repository;
    const { commit_id, path, position } = comment;
    return [`commit ${full_name}@${commit_id.slice(0, 6)}
Path: ${path}`, {
      reply: [`https://api.github.com/repos/${full_name}/commits/${commit_id}/comments`, { path, position }]
    }];
  });
  const onReference = createFactory((event, { repository, ref, ref_type, sender }) => {
    const ref_name = `${repository.full_name}${ref_type === "tag" ? "@" : ":"}${ref}`;
    return [`${sender.login} ${event}d ${ref_type} ${ref_name}`];
  });
  onReference("create");
  onReference("delete");
  on("fork", ({ repository, sender, forkee }) => {
    const { full_name, forks_count } = repository;
    return [`${sender.login} forked ${full_name} to ${forkee.full_name} (total ${forks_count} forks)`];
  });
  onComment("issue_comment", ({ issue, repository }) => {
    const { full_name } = repository;
    const { number, comments_url } = issue;
    const type = issue["pull_request"] ? "pull request" : "issue";
    return [`${type} ${full_name}#${number}`, {
      reply: [comments_url],
      padding: [16, 16, 16, 88]
    }];
  });
  const onIssue = createFactory((event, payload, handler) => {
    const { user, url, html_url, comments_url } = payload.issue;
    if (user.type === "Bot")
      return;
    const [message, replies] = handler(payload);
    return [message, {
      close: [url, comments_url],
      link: [html_url],
      react: [url + `/reactions`],
      reply: [comments_url],
      ...replies
    }];
  });
  onIssue("issues/opened", ({ repository, issue, sender }) => {
    const { full_name } = repository;
    const { title, body, number } = issue;
    return [[
      `${sender.login} opened an issue ${full_name}#${number}`,
      `Title: ${title}`,
      transform(body)
    ].join("\n")];
  });
  onIssue("issues/closed", ({ repository, issue, sender }) => {
    const { full_name } = repository;
    const { title, number } = issue;
    return [`${sender.login} closed issue ${full_name}#${number}
${title}`];
  });
  onComment("pull_request_review_comment", ({ repository, comment, pull_request }) => {
    const { full_name } = repository;
    const { number } = pull_request;
    const { path, url } = comment;
    return [`pull request review ${full_name}#${number}
Path: ${path}`, {
      reply: [url]
    }];
  });
  on("milestone/created", ({ repository, milestone, sender }) => {
    const { full_name } = repository;
    const { title, description } = milestone;
    return [`${sender.login} created milestone ${title} for ${full_name}
${description}`];
  });
  on("pull_request_review/submitted", ({ repository, review, pull_request }) => {
    if (!review.body)
      return;
    const { full_name } = repository;
    const { number, comments_url } = pull_request;
    const { user, html_url, body } = review;
    if (user.type === "Bot")
      return;
    return [[
      `${user.login} reviewed pull request ${full_name}#${number}`,
      transform(body)
    ].join("\n"), {
      link: [html_url],
      reply: [comments_url]
    }];
  });
  const onPullRequest = createFactory((event, payload, handler) => {
    const { user, url, html_url, issue_url, comments_url } = payload.pull_request;
    if (user.type === "Bot")
      return;
    const [message, replies] = handler(payload);
    return [message, {
      base: [url],
      close: [issue_url, comments_url],
      link: [html_url],
      merge: [url + "/merge"],
      rebase: [url + "/merge"],
      squash: [url + "/merge"],
      react: [issue_url + `/reactions`],
      reply: [comments_url],
      ...replies
    }];
  });
  onPullRequest("pull_request/closed", ({ repository, pull_request, sender }) => {
    const { full_name } = repository;
    const { title, number, merged } = pull_request;
    const type = merged ? "merged" : "closed";
    return [`${sender.login} ${type} pull request ${full_name}#${number}
${title}`];
  });
  onPullRequest("pull_request/reopened", ({ repository, pull_request, sender }) => {
    const { full_name } = repository;
    const { title, number } = pull_request;
    return [`${sender.login} reopened pull request ${full_name}#${number}
${title}`];
  });
  onPullRequest("pull_request/opened", ({ repository, pull_request, sender }) => {
    const { full_name, owner } = repository;
    const { title, base, head, body, number, draft } = pull_request;
    const prefix = new RegExp(`^${owner.login}:`);
    const baseLabel = base.label.replace(prefix, "");
    const headLabel = head.label.replace(prefix, "");
    return [[
      `${sender.login} ${draft ? "drafted" : "opened"} a pull request ${full_name}#${number} (${baseLabel} ← ${headLabel})`,
      `Title: ${title}`,
      transform(body)
    ].join("\n")];
  });
  onPullRequest("pull_request/review_requested", (payload) => {
    const { repository, pull_request, sender } = payload;
    const { full_name } = repository;
    const { number } = pull_request;
    return ["requested_reviewer" in payload ? `${sender.login} requested a review from ${payload.requested_reviewer.login} on ${full_name}#${number}` : `${sender.login} requested a review from team ${payload.requested_team.name} on ${full_name}#${number}`];
  });
  onPullRequest("pull_request/converted_to_draft", ({ repository, pull_request, sender }) => {
    const { full_name } = repository;
    const { number } = pull_request;
    return [`${sender.login} marked ${full_name}#${number} as draft`];
  });
  onPullRequest("pull_request/ready_for_review", ({ repository, pull_request, sender }) => {
    const { full_name } = repository;
    const { number } = pull_request;
    return [`${sender.login} marked ${full_name}#${number} as ready for review`];
  });
  on("push", ({ compare, pusher, sender, commits, repository, ref, before, after }) => {
    const { full_name } = repository;
    if (sender.type === "Bot")
      return;
    if (/^0+$/.test(before) || /^0+$/.test(after))
      return;
    return [[
      `${pusher.name} pushed to ${full_name}:${ref.replace(/^refs\/heads\//, "")}`,
      ...commits.map((c) => `[${c.id.slice(0, 6)}] ${transform(c.message)}`)
    ].join("\n"), {
      link: [compare]
    }];
  });
  on("star/created", ({ repository, sender }) => {
    const { full_name, stargazers_count } = repository;
    return [`${sender.login} starred ${full_name} (total ${stargazers_count} stargazers)`];
  });
}
__name(addListeners, "addListeners");

// packages/github/src/serve.ts
var import_sequelize2 = require("sequelize");
var import_icqq_cq_enable2 = require("icqq-cq-enable");

// packages/github/src/models/github.ts
var import_sequelize = require("sequelize");
var GithubTable;
((GithubTable2) => {
  GithubTable2.model = {
    name: import_sequelize.DataTypes.STRING,
    secret: import_sequelize.DataTypes.STRING
  };
})(GithubTable || (GithubTable = {}));

// packages/github/src/serve.ts
var import_plugin_prompt = require("@zhinjs/plugin-prompt");
var GitHub = class {
  constructor(bot, config) {
    this.bot = bot;
    this.config = config;
    this.history = /* @__PURE__ */ Object.create(null);
    this.http = bot.axios.extend({});
    bot.database.extend("User", {
      github_accessToken: import_sequelize2.DataTypes.STRING,
      github_refreshToken: import_sequelize2.DataTypes.STRING
    });
    bot.database.extend("Group", {
      github_webhooks: {
        type: import_sequelize2.DataTypes.TEXT,
        get() {
          return JSON.parse(this.getDataValue("github_webhooks") || "{}");
        },
        set(value) {
          this.setDataValue("github_webhooks", JSON.stringify(value));
        }
      }
    });
    bot.database.define("github", GithubTable.model);
  }
  async getTokens(params) {
    return this.http.post("https://github.com/login/oauth/access_token", {}, {
      params: {
        client_id: this.config.appId,
        client_secret: this.config.appSecret,
        ...params
      },
      headers: { Accept: "application/json" },
      timeout: this.config.requestTimeout
    });
  }
  async _request(method, url, replyMsg, data, headers) {
    this.bot.logger.debug(method, url, data);
    return this.http(method, url, {
      data,
      headers: {
        accept: "application/vnd.github.v3+json",
        authorization: `token ${replyMsg.member.github_accessToken}`,
        ...headers
      },
      timeout: this.config.requestTimeout
    });
  }
  async authorize(event, message) {
    const name2 = await event.prompt.text(message);
    if (name2) {
      await this.bot.execute({ name: "github.authorize", event, args: [name2] });
    } else {
      await event.reply("输入超时");
    }
  }
  async request(method, url, event, body, headers) {
    var _a;
    if (event.message_type !== "group")
      return "只能在群聊中使用";
    if (!event.member.github_accessToken) {
      return this.authorize(event, "要使用此功能，请对机器人进行授权。输入你的 GitHub 用户名。");
    }
    try {
      return await this._request(method, url, event, body, headers);
    } catch (error) {
      if (((_a = error.response) == null ? void 0 : _a.status) !== 401)
        throw error;
    }
    try {
      const data = await this.getTokens({
        refresh_token: event.member.github_refreshToken,
        grant_type: "refresh_token"
      });
      event.member.github_accessToken = data.access_token;
      event.member.github_refreshToken = data.refresh_token;
    } catch {
      return this.authorize(event, "令牌已失效，需要重新授权。输入你的 GitHub 用户名。");
    }
    return await this._request(method, url, event, body, headers);
  }
};
__name(GitHub, "GitHub");
var ReplyHandler = class {
  constructor(github, botEvent, content) {
    this.github = github;
    this.botEvent = botEvent;
    this.content = content;
  }
  async request(method, url, message, body, headers) {
    try {
      await this.github.request(method, url, this.botEvent, body, headers);
    } catch (err) {
      return message;
    }
  }
  link(url) {
    return url;
  }
  react(url) {
    return this.request("POST", url, "发送失败", {
      content: this.content
    }, {
      accept: "application/vnd.github.squirrel-girl-preview"
    });
  }
  async transform(source) {
    const [{ type, url, text }] = (0, import_icqq_cq_enable2.fromCqcode)(source);
    return type !== "image" ? text : `![${text}](${url})`;
  }
  async reply(url, params) {
    return this.request("POST", url, "发送失败", {
      body: await this.transform(this.content),
      ...params
    });
  }
  base(url) {
    return this.request("PATCH", url, "修改失败", {
      base: this.content
    });
  }
  merge(url, method) {
    const [title] = this.content.split("\n", 1);
    const message = this.content.slice(title.length);
    return this.request("PUT", url, "操作失败。", {
      merge_method: method,
      commit_title: title.trim(),
      commit_message: message.trim()
    });
  }
  rebase(url) {
    return this.merge(url, "rebase");
  }
  squash(url) {
    return this.merge(url, "squash");
  }
  async close(url, commentUrl) {
    if (this.content)
      await this.reply(commentUrl);
    await this.request("PATCH", url, "操作失败", {
      state: "closed"
    });
  }
};
__name(ReplyHandler, "ReplyHandler");

// packages/github/src/index.ts
var import_querystring = require("querystring");
var import_icqq2 = require("icqq");
var import_message = require("icqq/lib/message");
var import_crypto = require("crypto");
var name = "github";
var using = ["database", "http", "utils", "prompt"];
function install(bot, config) {
  config.path = (0, import_zhin.sanitize)(config.path);
  const { database } = bot;
  const { appId, redirect } = config;
  const subscriptions = {};
  bot.service("github", GitHub, config);
  bot.middleware(async (event, next) => {
    await next();
    const mathReg = /^(?:https?:\/\/)?(?:www\.)?github\.com\/([^/]+)\/([^/]+)\/?$/;
    const match = event.toCqcode().match(mathReg);
    if (!match)
      return;
    const [, owner, repo] = match;
    const url = `https://opengraph.github.com/repo/${owner}/${repo}`;
    event.reply(import_icqq2.segment.image(url));
  });
  const tokens = /* @__PURE__ */ Object.create(null);
  bot.router.get(config.path + "/authorize", async (_ctx) => {
    const token = _ctx.query.state;
    if (!token || Array.isArray(token))
      return _ctx.status = 400;
    const id = tokens[token];
    if (!id)
      return _ctx.status = 403;
    delete tokens[token];
    const { code, state } = _ctx.query;
    const data = await bot.github.getTokens({ code, state, redirect_uri: redirect });
    await database.model("User").update({
      github_accessToken: data.access_token,
      github_refreshToken: data.refresh_token
    }, { where: { id } });
    return _ctx.status = 200;
  });
  bot.command("github [name]", "group").desc("github仓库管理指令").alias("gh").check(({ event }) => {
    if (bot.isAdmin(event.sender.user_id) || bot.isMaster(event.sender.user_id))
      return;
    return "权限不足";
  }).option("list", "-l").option("add", "-a").option("delete", "-d").action(async ({ event, options }, name2) => {
    if (options.list) {
      const names = Object.keys(event.group.github_webhooks || {});
      if (!names.length)
        return "当前没有监听仓库";
      return names.sort().join("\n");
    }
    if (options.add || options.delete) {
      if (!name2)
        return "请输入仓库名";
      if (!repoRegExp.test(name2))
        return "仓库名无效";
      name2 = name2.toLowerCase();
      const github_webhooks = event.group.github_webhooks;
      if (options.add) {
        if (github_webhooks[name2])
          return "已添加过仓库 " + name2;
        const [repo] = await bot.database.get("github", { name: [name2] });
        if (!repo) {
          const dispose = bot.middleware((event2, next) => {
            dispose();
            const cqCode = event2.toCqcode().trim();
            if (cqCode && cqCode !== "." && cqCode !== "。")
              return next();
            return bot.execute({
              name: "github.repos",
              event: event2,
              args: [name2],
              options: { add: true, subscribe: true }
            });
          });
          return `尚未添加过仓库 ${name2}。发送空行或句号以立即添加并订阅该仓库`;
        }
        github_webhooks[name2] = (0, import_zhin.deepClone)(defaultEvents);
        await bot.database.set("Group", { group_id: event.group_id }, { github_webhooks });
        subscribe(name2, event.group_id, github_webhooks[name2]);
        return "添加成功";
      } else if (options.delete) {
        if (!github_webhooks[name2])
          return "尚未在当前群聊订阅过仓库" + name2;
        delete github_webhooks[name2];
        await bot.database.set("Group", { group_id: event.group_id }, { github_webhooks });
        unsubscribe(name2, event.group_id);
        return "删除成功";
      }
    }
    return bot.execute({ event, name: "help", args: ["github"] });
  });
  bot.command("github/github.authorize <user>", "group").alias("github.auth").action(async ({ event }, user) => {
    if (!user)
      return "请输入用户名";
    const token = import_zhin.Random.id();
    tokens[token] = event.member.id;
    const url = "https://github.com/login/oauth/authorize?" + (0, import_querystring.encode)({
      client_id: appId,
      state: token,
      redirect_uri: redirect,
      scope: "admin:repo_hook,repo",
      login: user
    });
    return "点击下面的链接继续操作：\n" + url;
  });
  const repoRegExp = /^[\w.-]+\/[\w.-]+$/;
  bot.command("github/github.repos [name:string]", "group").option("add", "-a").option("delete", "-d").option("subscribe", "-s").action(async ({ event, options }, name2) => {
    if (options.add || options.delete) {
      if (!name2)
        return "请输入仓库名";
      if (!repoRegExp.test(name2))
        return "仓库名无效";
      if (!event.member.github_accessToken) {
        return bot.github.authorize(event, "要使用此功能，请对机器人进行授权。输入你的 GitHub 用户名。");
      }
      name2 = name2.toLowerCase();
      const url = `https://api.github.com/repos/${name2}/hooks`;
      const [repo] = await bot.database.get("github", { name: [name2] });
      if (options.add) {
        if (repo)
          return "重复添加";
        const secret = import_zhin.Random.id();
        let data;
        try {
          data = await bot.github.request("POST", url, event, {
            events: ["*"],
            config: {
              secret,
              url: bot.options.plugins.http.selfUrl + config.path + "/webhook"
            }
          });
        } catch (err) {
          if (!err.response)
            throw err;
          if (err.response.status === 404) {
            return "未找到仓库 " + name2;
          } else if (err.response.status === 403) {
            return "访问受限";
          } else {
            bot.logger.warn(err);
            return "添加失败";
          }
        }
        await bot.database.add("github", { name: name2, id: data.id, secret });
        if (!options.subscribe)
          return "添加成功";
        return bot.execute({
          name: "github",
          event,
          args: [name2],
          options: { add: true }
        });
      } else {
        if (!repo)
          return "删除失败";
        try {
          await bot.github.request("DELETE", `${url}/${repo.toJSON().id}`, event);
        } catch (err) {
          if (!err.response)
            throw err;
          if (err.response.status !== 404) {
            bot.logger.warn(err);
            return "删除失败";
          }
        }
        async function updateChannels() {
          const groups = await bot.database.get("Group");
          for (const group of groups) {
            const { github_webhooks } = group.toJSON();
            if (!github_webhooks)
              continue;
            const shouldUpdate = github_webhooks[name2];
            delete github_webhooks[name2];
            if (shouldUpdate) {
              await group.update({ github_webhooks });
            }
          }
        }
        __name(updateChannels, "updateChannels");
        unsubscribe(name2);
        await Promise.all([
          updateChannels(),
          bot.database.delete("github", { name: [name2] })
        ]);
        return "删除成功";
      }
    }
    const repos = await bot.database.get("github", {});
    if (!repos.length)
      return "当前没有监听的仓库";
    return repos.map((repo) => repo.toJSON().name).join("\n");
  });
  function subscribe(repo, group_id, meta) {
    (subscriptions[repo] || (subscriptions[repo] = {}))[group_id] = meta;
  }
  __name(subscribe, "subscribe");
  function unsubscribe(repo, group_id) {
    if (!group_id)
      return delete subscriptions[repo];
    delete subscriptions[repo][group_id];
    if (!Object.keys(subscriptions[repo]).length) {
      delete subscriptions[repo];
    }
  }
  __name(unsubscribe, "unsubscribe");
  async function request(method, url, event, body, message) {
    return bot.github.request(method, "https://api.github.com" + url, event, body).then(() => message + "成功").catch((err) => {
      bot.logger.warn(err);
      return message + "失败";
    });
  }
  __name(request, "request");
  bot.command("github/github.issue [title] [body:text]", "group").option("repo", "-r [repo:string]").action(async ({ event, options }, title, body) => {
    if (!options.repo)
      return "请输入仓库名";
    if (!repoRegExp.test(options.repo))
      return "仓库名无效";
    if (!event.member.github_accessToken) {
      return bot.github.authorize(event, "要使用此功能，请对机器人进行授权。输入你的 GitHub 用户名。");
    }
    return request("POST", `/repos/${options.repo}/issues`, event, {
      title,
      body
    }, "创建");
  });
  bot.command("github/github.star [repo]", "group").option("repo", "-r [repo:string]").action(async ({ event, options }) => {
    if (!options.repo)
      return "请输入仓库名";
    if (!repoRegExp.test(options.repo))
      return "仓库名无效";
    if (!event.member.github_accessToken) {
      return bot.github.authorize(event, "要使用此功能，请对机器人进行授权。输入你的 GitHub 用户名。");
    }
    return request("PUT", `/user/starred/${options.repo}`, event, null, "操作");
  });
  bot.after("ready", async () => {
    const channels = await bot.database.get("Group");
    for (const channel of channels) {
      const { github_webhooks, group_id } = channel.toJSON();
      if (!github_webhooks)
        continue;
      for (const repo in github_webhooks) {
        subscribe(repo, group_id, github_webhooks[repo]);
      }
    }
  });
  const reactions = ["+1", "-1", "laugh", "confused", "heart", "hooray", "rocket", "eyes"];
  function safeParse(source) {
    try {
      return JSON.parse(source);
    } catch {
    }
  }
  __name(safeParse, "safeParse");
  bot.router.post(config.path + "/webhook", async (_ctx) => {
    const event = _ctx.headers["x-github-event"];
    const signature = _ctx.headers["x-hub-signature-256"];
    const id = _ctx.headers["x-github-delivery"];
    const webhookId = +_ctx.headers["x-github-hook-id"];
    const payload = safeParse(_ctx.request.body.payload);
    if (!payload)
      return _ctx.status = 400;
    const fullEvent = payload.action ? `${event}/${payload.action}` : event;
    bot.logger.debug("received %s (%s)", fullEvent, id);
    const [data] = await database.get("github", { id: webhookId });
    if (!data)
      return _ctx.status = 202;
    if (signature !== `sha256=${(0, import_crypto.createHmac)("sha256", data.toJSON().secret).update(_ctx.request.rawBody).digest("hex")}`) {
      return _ctx.status = 403;
    }
    const fullName = payload.repository.full_name.toLowerCase();
    if (data.toJSON().name !== fullName) {
      await database.set("github", { id: webhookId }, { name: fullName, secret: data.toJSON().secret });
      unsubscribe(data.toJSON().name);
      const groups = await bot.database.get("Group");
      for (const group of groups) {
        const { github_webhooks, group_id } = group.toJSON();
        if (!github_webhooks)
          continue;
        const shouldUpdate = github_webhooks[data.toJSON().name];
        if (shouldUpdate) {
          github_webhooks[fullName] = shouldUpdate;
          subscribe(fullName, group_id, github_webhooks[fullName]);
          delete github_webhooks[data.toJSON().name];
          await group.update({ github_webhooks });
        }
      }
    }
    _ctx.status = 200;
    if (payload.action) {
      bot.emit(`github/${fullEvent}`, payload);
    }
    bot.emit(`github/${event}`, payload);
  });
  bot.middleware((session, next) => {
    if (!session.source || session.message_type !== "group")
      return next();
    const body = session.source.message.trim();
    const payloads = bot.github.history[(0, import_message.genGroupMessageId)(session.group_id, session.sender.user_id, session.source.seq, session.source.rand, session.source.time)];
    if (!body || !payloads)
      return next();
    let name2, message;
    name2 = reactions.includes(body) ? "react" : "reply";
    message = body;
    const payload = payloads[name2];
    if (!payload)
      return next();
    const handler = new ReplyHandler(bot.github, session, message);
    return handler[name2](...payload);
  });
  addListeners((event, handler) => {
    const base = (0, import_zhin.camelize)(event.split("/", 1)[0]);
    bot.on(`github/${event}`, async (payload) => {
      const repoConfig = subscriptions[payload.repository.full_name.toLowerCase()] || {};
      console.log("repoConfig", repoConfig);
      const targets = Object.keys(repoConfig).filter((id) => {
        const baseConfig = repoConfig[id][base] || (0, import_zhin.deepClone)(defaultEvents);
        if (baseConfig === false)
          return;
        if (payload.action && baseConfig !== true) {
          const action = (0, import_zhin.camelize)(payload.action);
          const actionConfig = baseConfig[action];
          if (actionConfig === false)
            return;
          if (actionConfig !== true && !(defaultEvents[base] || {})[action])
            return;
        }
        return true;
      });
      if (!targets.length)
        return;
      const result = handler(payload);
      if (!result)
        return;
      bot.logger.info("broadcast", result[0]);
      const messageIds = await bot.broadcast([`group:${targets}`], (config.messagePrefix || "[GitHub]") + result[0]);
      for (const id of messageIds) {
        bot.github.history[id] = result[1];
      }
      bot.setTimeout(() => {
        for (const id of messageIds) {
          delete bot.github.history[id];
        }
      }, config.replyTimeout);
    });
  });
}
__name(install, "install");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  install,
  name,
  using
});
//# sourceMappingURL=index.js.map
